import {
  styleExpressionProperty
} from "./chunk.6UWYSL2J.js";
import {
  tokens
} from "./chunk.MM4R6TVG.js";
import {
  GdsElement
} from "./chunk.VDIB4JW2.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/media/video/video.ts
import { property, query } from "lit/decorators.js";

// libs/core/src/components/media/video/video.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: contents;
  }

  figure {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
    font-size: 0;
    width: 100%;
    height: auto;
    overflow: hidden;
  }

  video {
    display: flex;
    width: 100%;
    height: 100%;
  }
`;
var video_style_default = style;

// libs/core/src/components/media/video/video.ts
var GdsVideo = class extends GdsElement {
  // Method to programmatically apply video settings
  applyVideoSettings() {
    if (this.videoElement) {
      this.videoElement.src = this.src || "";
      this.videoElement.poster = this.poster || "";
      this.videoElement.muted = this.muted || false;
      this.videoElement.autoplay = this.autoplay || false;
      this.videoElement.loop = this.loop || false;
      this.videoElement.playsInline = this.playsinline || false;
    }
  }
  render() {
    return html`<figure><video></video></figure>`;
  }
  firstUpdated() {
    this.applyVideoSettings();
  }
};
GdsVideo.styles = [tokens, video_style_default];
__decorateClass([
  styleExpressionProperty({
    property: "aspect-ratio",
    selector: "figure",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "aspect-ratio", 2);
__decorateClass([
  styleExpressionProperty({
    property: "object-position",
    selector: "video",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "object-position", 2);
__decorateClass([
  styleExpressionProperty({
    property: "inset",
    selector: "figure",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "inset", 2);
__decorateClass([
  styleExpressionProperty({
    property: "width",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "width", 2);
__decorateClass([
  styleExpressionProperty({
    property: "height",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "height", 2);
__decorateClass([
  styleExpressionProperty({
    property: "opacity",
    selector: "figure",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "opacity", 2);
__decorateClass([
  styleExpressionProperty({
    property: "object-fit",
    selector: "video",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "object-fit", 2);
__decorateClass([
  styleExpressionProperty({
    property: "pointer-events",
    selector: "video",
    valueTemplate: (v) => v
  })
], GdsVideo.prototype, "pointer-events", 2);
__decorateClass([
  styleExpressionProperty({
    property: "border-radius",
    selector: "figure",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsVideo.prototype, "border-radius", 2);
__decorateClass([
  property()
], GdsVideo.prototype, "src", 2);
__decorateClass([
  property()
], GdsVideo.prototype, "poster", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "muted", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "playsinline", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "autoplay", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "loop", 2);
__decorateClass([
  query("video")
], GdsVideo.prototype, "videoElement", 2);
GdsVideo = __decorateClass([
  gdsCustomElement("gds-video")
], GdsVideo);

export {
  GdsVideo
};
