import {
  forwardAttributes
} from "./chunk.IZCY56TH.js";
import {
  GdsFormControlElement
} from "./chunk.JIIVJ7QV.js";
import {
  constrainSlots
} from "./chunk.KBYQYDL3.js";
import {
  tokens
} from "./chunk.MM4R6TVG.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/input/input.ts
import { property, query, queryAsync, state } from "lit/decorators.js";
import { until } from "lit/directives/until.js";
import { nothing } from "lit/html.js";
import { when } from "lit/directives/when.js";
import { choose } from "lit/directives/choose.js";
import { msg } from "@lit/localize";

// libs/core/src/components/input/input.styles.ts
import { css } from "lit";
var styles = css`
  @layer tokens, a11y, base, simplified;

  @layer tokens {
    :host {
      --_transition: all 368ms cubic-bezier(0.4, 0, 0.2, 1);
    }
  }

  @layer a11y {
    @media (prefers-reduced-motion: reduce) {
      :host {
        --_transition: none;
      }
    }

    @media (prefers-reduced-transparency: reduce) {
      :host {
        --_transparency: 1;
      }
    }
  }

  @layer base {
    * {
      box-sizing: border-box;
    }

    :host {
      width: 100%;
      contain: layout;
      isolation: isolate;
    }

    :host([size='small']) input {
      font-size: var(--gds-text-size-detail-s);
      line-height: var(--gds-text-line-height-detail-s);
    }

    .field {
      transition: var(--_transition);
      position: relative;
      outline: 2px solid transparent;
      outline-offset: 2px;

      &:has(input:focus-visible) {
        border-color: var(--gds-color-l3-border-primary);
        outline-color: currentColor;
      }

      &.invalid:has(input:focus-visible) {
        border-color: var(--gds-color-l3-border-negative);
      }
    }

    @media (hover: hover) {
      .field {
        &:hover {
          background: color-mix(
            in srgb,
            var(--gds-color-l3-background-secondary),
            var(--gds-color-l3-states-light-hover)
          );
        }

        &.invalid:hover {
          background: color-mix(
            in srgb,
            var(--gds-color-l3-background-negative-secondary),
            var(--gds-color-l3-states-negative-hover)
          );
        }
      }
    }

    input {
      appearance: none;
      background-color: transparent;
      border: 0;
      box-sizing: border-box;
      font-family: inherit;
      margin: unset;
      outline: none;
      overflow: hidden;
      padding: unset;
      transition: var(--_transition);
      width: 100%;
      font-size: var(--gds-text-size-detail-m);
      line-height: var(--gds-text-line-height-detail-m);
    }

    :host([size='small']) slot[name='lead']::slotted(*) {
      line-height: 18px;
    }

    :host([size='small']) slot[name='lead']::slotted(*) {
      min-width: var(--gds-space-m);
      max-width: var(--gds-space-m);
      display: flex;
    }

    slot[name='lead']::slotted(*) {
      min-width: var(--gds-space-l);
      display: flex;
    }

    .extended-supporting-text {
      opacity: 1;
      translate: 0;
      transition: var(--_transition);

      @starting-style {
        opacity: 0;
        translate: 0 2px;
      }
    }
  }

  @layer simplified {
    // ...
  }
`;

// libs/core/src/components/input/input.ts
var _renderDefault, renderDefault_fn, _renderFloatingLabel, renderFloatingLabel_fn, _forwardableAttrs, _handleOnInput, _handleOnChange, _handleFieldClick, _handleClearBtnClick, _handleSupportingTextBtnClick, _renderSlotLead, renderSlotLead_fn, _renderSlotTrail, renderSlotTrail_fn, _handleSlotChange, handleSlotChange_fn, _renderNativeInput, renderNativeInput_fn, _renderSupportingText, renderSupportingText_fn, _renderExtendedSupportingText, renderExtendedSupportingText_fn, _renderClearButton, renderClearButton_fn, _shouldShowRemainingChars, shouldShowRemainingChars_get, _renderRemainingCharsBadge, renderRemainingCharsBadge_fn, _asyncRenderExtendedSupportingTextButton, asyncRenderExtendedSupportingTextButton_fn;
var GdsInput = class extends GdsFormControlElement {
  constructor() {
    super();
    __privateAdd(this, _renderDefault);
    // variant="floatingLabel"
    __privateAdd(this, _renderFloatingLabel);
    __privateAdd(this, _renderSlotLead);
    __privateAdd(this, _renderSlotTrail);
    __privateAdd(this, _handleSlotChange);
    __privateAdd(this, _renderNativeInput);
    __privateAdd(this, _renderSupportingText);
    __privateAdd(this, _renderExtendedSupportingText);
    __privateAdd(this, _renderClearButton);
    __privateAdd(this, _shouldShowRemainingChars);
    __privateAdd(this, _renderRemainingCharsBadge);
    /**
     * Returns a promise that resolves when the DOM query for the extended supporting text slot has resolved.
     * If the slot is empty, an empty template is returned, otherwise the support text toggle button is returned.
     */
    __privateAdd(this, _asyncRenderExtendedSupportingTextButton);
    this.value = "";
    this.label = "";
    this.supportingText = "";
    this.showExtendedSupportingText = false;
    this.disabled = false;
    this.clearable = false;
    this.maxlength = Number.MAX_SAFE_INTEGER;
    this.variant = "default";
    this.size = "default";
    this.trailSlotOccupied = false;
    // Any attribute name added here will get forwarded to the native <input> element.
    __privateAdd(this, _forwardableAttrs, (attr) => ["type", "placeholder", "required"].includes(attr.name));
    __privateAdd(this, _handleOnInput, (e) => {
      const element = e.target;
      this.value = element.value;
    });
    __privateAdd(this, _handleOnChange, (e) => {
      const element = e.target;
      this.value = element.value;
      this.dispatchEvent(
        new Event("change", {
          bubbles: true,
          composed: true
        })
      );
    });
    __privateAdd(this, _handleFieldClick, () => {
      this.elInputAsync.then((el) => el.focus());
    });
    __privateAdd(this, _handleClearBtnClick, () => {
      this.value = "";
    });
    __privateAdd(this, _handleSupportingTextBtnClick, () => {
      this.showExtendedSupportingText = !this.showExtendedSupportingText;
      this.dispatchEvent(
        new CustomEvent("gds-ui-state", {
          bubbles: true,
          composed: true,
          detail: this.showExtendedSupportingText
        })
      );
    });
    constrainSlots(this);
  }
  connectedCallback() {
    super.connectedCallback();
  }
  disconnectedCallback() {
    super.disconnectedCallback();
  }
  render() {
    return html`${choose(this.variant, [
      ["default", () => __privateMethod(this, _renderDefault, renderDefault_fn).call(this)],
      ["floating-label", () => __privateMethod(this, _renderFloatingLabel, renderFloatingLabel_fn).call(this)]
    ])}`;
  }
  _getValidityAnchor() {
    return this.elInput;
  }
};
_renderDefault = new WeakSet();
renderDefault_fn = function() {
  return html`
      <gds-flex
        level="3"
        flex-direction="column"
        width="100%"
        gap="xs"
        user-select="${this.disabled ? "none" : "auto"}"
        pointer-events="${this.disabled ? "none" : "auto"}"
        color="${this.disabled ? "disabled" : this.invalid ? "negative" : "tertiary"}"
      >
        <gds-flex
          class="head"
          align-items="center"
          justify-content="space-between"
          padding="3xs 0 0 0"
        >
          <gds-flex flex-direction="column">
            <gds-text
              font-weight="book"
              font-size="${this.size === "small" ? "detail-s" : "detail-m"}"
            >
              <label for="input"> ${this.label} </label>
            </gds-text>
            ${when(this.supportingText, () => __privateMethod(this, _renderSupportingText, renderSupportingText_fn).call(this))}
          </gds-flex>
          ${until(__privateMethod(this, _asyncRenderExtendedSupportingTextButton, asyncRenderExtendedSupportingTextButton_fn).call(this), nothing)}
        </gds-flex>

        ${__privateMethod(this, _renderExtendedSupportingText, renderExtendedSupportingText_fn).call(this)}

        <gds-flex
          level="3"
          position="relative"
          align-items="center"
          justify-content="center"
          gap="${this.size === "small" ? "2xs" : "xs"}"
          padding="${this.size === "small" ? "xs s" : !this.trailSlotOccupied ? "xs xs xs m" : "xs m"}"
          min-block-size="${this.size === "small" ? "xl" : "3xl"}"
          block-size="${this.size === "small" ? "xl" : "3xl"}"
          border-radius="xs"
          .background=${this.disabled ? "disabled" : this.invalid ? "negative-secondary" : "secondary"}
          .border=${this.disabled ? "" : this.invalid ? "4xs/negative" : "4xs/secondary"}
          class="field ${this.invalid ? "invalid" : ""}"
          @click=${__privateGet(this, _handleFieldClick)}
          cursor="text"
        >
          ${__privateMethod(this, _renderSlotLead, renderSlotLead_fn).call(this)} ${__privateMethod(this, _renderNativeInput, renderNativeInput_fn).call(this)}
          <gds-flex gap="xs" align-items="center">
            ${__privateMethod(this, _renderClearButton, renderClearButton_fn).call(this)} ${__privateMethod(this, _renderSlotTrail, renderSlotTrail_fn).call(this)}
          </gds-flex>
        </gds-flex>

        <gds-flex
          class="foot"
          align-items="flex-start"
          justify-content="space-between"
          aria-live="polite"
          gap="xl"
        >
          ${when(
    this.invalid,
    () => html`
              <gds-flex
                align-items="flex-start"
                gap="${this.size === "small" ? "2xs" : "xs"}"
                margin="2xs 0 0 0"
              >
                <gds-flex min-width="18px">
                  <gds-icon-triangle-exclamation
                    width="${this.size === "small" ? "16" : "18"}"
                    height="${this.size === "small" ? "16" : "18"}"
                    solid
                  >
                  </gds-icon-triangle-exclamation>
                </gds-flex>
                <gds-text
                  tag="span"
                  font-size="${this.size === "small" ? "detail-xs" : "detail-s"}"
                  font-weight="book"
                  class="error-text"
                >
                  ${this.validationMessage}
                </gds-text>
              </gds-flex>
            `
  )}
          <gds-flex
            margin="0 0 0 auto"
            min-width="4ch"
            justify-content="flex-end"
          >
            ${when(
    __privateGet(this, _shouldShowRemainingChars, shouldShowRemainingChars_get),
    () => __privateMethod(this, _renderRemainingCharsBadge, renderRemainingCharsBadge_fn).call(this)
  )}
          </gds-flex>
        </gds-flex>
      </gds-flex>
    `;
};
_renderFloatingLabel = new WeakSet();
renderFloatingLabel_fn = function() {
  return nothing;
};
_forwardableAttrs = new WeakMap();
_handleOnInput = new WeakMap();
_handleOnChange = new WeakMap();
_handleFieldClick = new WeakMap();
_handleClearBtnClick = new WeakMap();
_handleSupportingTextBtnClick = new WeakMap();
_renderSlotLead = new WeakSet();
renderSlotLead_fn = function() {
  return html` <slot name="lead"></slot> `;
};
_renderSlotTrail = new WeakSet();
renderSlotTrail_fn = function() {
  return html`
      <slot
        name="trail"
        gds-allow="gds-badge"
        @slotchange=${__privateMethod(this, _handleSlotChange, handleSlotChange_fn)}
      ></slot>
    `;
};
_handleSlotChange = new WeakSet();
handleSlotChange_fn = function(event) {
  const slot = event.target;
  const assignedNodes = slot.assignedNodes({ flatten: true });
  this.trailSlotOccupied = assignedNodes.length > 0 && assignedNodes.some(
    (node) => {
      var _a;
      return node.nodeType === Node.ELEMENT_NODE || node.nodeType === Node.TEXT_NODE && ((_a = node.textContent) == null ? void 0 : _a.trim()) !== "";
    }
  );
};
_renderNativeInput = new WeakSet();
renderNativeInput_fn = function() {
  return html`
      <input
        @input=${__privateGet(this, _handleOnInput)}
        @change=${__privateGet(this, _handleOnChange)}
        style="${this.invalid ? "color: var(--gds-color-l3-content-negative);" : this.disabled ? "color: currentColor;pointer-events:none;" : null}"
        .value=${this.value}
        id="input"
        ?disabled=${this.disabled}
        aria-describedby="supporting-text"
        placeholder=" "
        ${forwardAttributes(__privateGet(this, _forwardableAttrs))}
      />
    `;
};
_renderSupportingText = new WeakSet();
renderSupportingText_fn = function() {
  return html`
      <gds-text
        level="3"
        font-size="${this.size === "small" ? "detail-s" : "detail-m"}"
        .color="${this.disabled ? "disabled" : this.invalid ? "negative" : "tertiary"}"
        class="supporting-text"
        id="supporting-text"
      >
        ${this.supportingText}
      </gds-text>
    `;
};
_renderExtendedSupportingText = new WeakSet();
renderExtendedSupportingText_fn = function() {
  return html`
      <gds-card
        level="3"
        class="extended-supporting-text"
        padding="s m"
        border-radius="xs"
        background="secondary"
        color="tertiary"
        display="${this.showExtendedSupportingText ? "block" : "none"}"
      >
        <gds-text font-size="body-s">
          <slot
            name="extended-supporting-text"
            @slotchange=${() => this.requestUpdate()}
          ></slot>
        </gds-text>
      </gds-card>
    `;
};
_renderClearButton = new WeakSet();
renderClearButton_fn = function() {
  if (this.clearable && this.value.length > 0)
    return html`
        <gds-button
          size="${this.size === "small" ? "xs" : "small"}"
          rank="tertiary"
          variant="${this.invalid ? "negative" : ""}"
          ?disabled="${this.disabled}"
          label="${msg("Clear input")}"
          @click=${__privateGet(this, _handleClearBtnClick)}
        >
          <gds-icon-cross-small />
        </gds-button>
      `;
  else
    return nothing;
};
_shouldShowRemainingChars = new WeakSet();
shouldShowRemainingChars_get = function() {
  return this.maxlength < Number.MAX_SAFE_INTEGER;
};
_renderRemainingCharsBadge = new WeakSet();
renderRemainingCharsBadge_fn = function() {
  const remaining = this.maxlength - this.value.length;
  let variant;
  if (remaining < 0) {
    variant = "negative";
  } else if (remaining < 20) {
    variant = "warning";
  } else {
    variant = "positive";
  }
  return html`<gds-badge variant="${variant}">${remaining}</gds-badge>`;
};
_asyncRenderExtendedSupportingTextButton = new WeakSet();
asyncRenderExtendedSupportingTextButton_fn = async function() {
  return this.elExtendedSupportingTextSlot.then((slot) => {
    if (slot && slot.assignedElements().length > 0)
      return html`
          <gds-button
            size="small"
            rank="tertiary"
            label="${msg("Show extended supporting text")}"
            @click=${__privateGet(this, _handleSupportingTextBtnClick)}
          >
            <gds-icon-circle-info ?solid=${this.showExtendedSupportingText} />
          </gds-button>
        `;
    else
      return nothing;
  });
};
GdsInput.styles = [tokens, styles];
__decorateClass([
  property()
], GdsInput.prototype, "value", 2);
__decorateClass([
  property()
], GdsInput.prototype, "label", 2);
__decorateClass([
  property({ attribute: "supporting-text" })
], GdsInput.prototype, "supportingText", 2);
__decorateClass([
  property({
    attribute: "show-extended-supporting-text",
    type: Boolean,
    reflect: true
  })
], GdsInput.prototype, "showExtendedSupportingText", 2);
__decorateClass([
  property({
    attribute: "disabled",
    type: Boolean,
    reflect: true
  })
], GdsInput.prototype, "disabled", 2);
__decorateClass([
  property({ type: Boolean })
], GdsInput.prototype, "clearable", 2);
__decorateClass([
  property({ type: Number })
], GdsInput.prototype, "maxlength", 2);
__decorateClass([
  property({ type: String })
], GdsInput.prototype, "variant", 2);
__decorateClass([
  property({ type: String })
], GdsInput.prototype, "size", 2);
__decorateClass([
  queryAsync("input")
], GdsInput.prototype, "elInputAsync", 2);
__decorateClass([
  query("input")
], GdsInput.prototype, "elInput", 2);
__decorateClass([
  queryAsync('slot[name="extended-supporting-text"]')
], GdsInput.prototype, "elExtendedSupportingTextSlot", 2);
__decorateClass([
  state()
], GdsInput.prototype, "trailSlotOccupied", 2);
GdsInput = __decorateClass([
  gdsCustomElement("gds-input")
], GdsInput);

export {
  GdsInput
};
