import {
  GdsFormControlElement
} from "./chunk.JIIVJ7QV.js";
import {
  constrainSlots
} from "./chunk.KBYQYDL3.js";
import {
  observeLightDOM
} from "./chunk.WM7HBMMV.js";
import {
  TransitionalStyles
} from "./chunk.CWRLA7VT.js";
import {
  watch
} from "./chunk.2WO4NHJ2.js";
import {
  tokens
} from "./chunk.MM4R6TVG.js";
import {
  gdsCustomElement,
  getScopedTagName,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod,
  __privateSet
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/dropdown/dropdown.ts
import { property, query, queryAsync } from "lit/decorators.js";
import { unsafeHTML } from "lit/directives/unsafe-html.js";
import { when } from "lit/directives/when.js";
import { ifDefined } from "lit/directives/if-defined.js";
import { classMap } from "lit/directives/class-map.js";
import { msg, str, updateWhenLocaleChanges } from "@lit/localize";

// libs/core/src/components/dropdown/dropdown.styles.ts
import { css } from "lit";
var style = css`
  @layer base, reset;

  @layer base {
    :host {
      display: flex;
      flex-direction: column;
      color: var(--gds-sys-color-base800);
      font-family: inherit;
    }

    button {
      display: flex;
      align-items: center;
      justify-content: space-between;
      gap: var(--gds-space-m);
      height: var(--gds-space-3xl);
      border: var(--gds-space-4xs) solid #6f6f6f;
      border-radius: var(--gds-space-xs);
      padding-inline: var(--gds-space-m);
      cursor: pointer;
      box-sizing: border-box;
      font-size: var(--gds-space-m);
      font-family: inherit;

      // TODO: Update colors to use tokens
      border-color: #6f6f6f;
      color: #1b1b1b;
      background-color: #e2e2e2;

      &.small {
        height: var(--gds-space-xl);
        padding: var(--gds-space-s);
        padding-right: var(--gds-space-xs);
        font-size: calc(var(--gds-space-s) + 2px);

        .icon {
          width: var(--gds-space-l);
          height: var(--gds-space-l);
        }
      }

      &:hover {
        background-color: #cecece;
      }

      .icon {
        display: flex;
        align-items: center;
        justify-content: center;
        box-sizing: border-box;
        height: var(--gds-space-xl);
        width: var(--gds-space-xl);
      }

      &[aria-expanded='true'] ::part(icon) {
        transform: scaleY(-1);
      }
    }

    slot[name='trigger'] > span {
      display: block;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
    }

    label {
      font-size: var(--gds-text-size-detail-m);
      line-height: var(--gds-text-line-height-detail-m);
      font-weight: var(--gds-text-weight-book);
      padding-block: var(--gds-space-2xs);
      font-family: inherit;
    }

    input[type='text'] {
      border-radius: var(--gds-space-xs);
      border-bottom-left-radius: 0;
      border-bottom-right-radius: 0;
      font-size: inherit;
      line-height: inherit;
      border: none;
      outline: none;
      color: var(--gds-sys-color-base800);
      border-bottom: 1px solid var(--gds-sys-color-base400);
      width: 100%;
      padding: var(--gds-space-m);
      font-weight: var(--gds-text-weight-book);
      flex: 1;
      box-sizing: border-box;
      font-family: inherit;

      &:focus {
        border-color: var(--gds-sys-color-base800);
      }

      &::placeholder {
        color: currrentColor;
        font-family: inherit;
        font-weight: var(--gds-text-weight-book);
        color: var(--gds-sys-color-base800);
      }
    }
  }
`;
var dropdown_styles_default = style;

// libs/core/src/components/dropdown/dropdown.ts
var _optionElements, _calcMaxHeight, _handleSearchFieldKeyUp, _handleSearchFieldKeyDown, _handleListboxKeyDown, _handleOptionFocusChange, _handleSelectionChange, handleSelectionChange_fn, _registerAutoCloseListener, registerAutoCloseListener_fn, _unregisterAutoCloseListener, unregisterAutoCloseListener_fn, _blurCloseListener, _tabCloseListener;
var GdsDropdown = class extends GdsFormControlElement {
  constructor() {
    super();
    /**
     * Selects an option in the dropdown.
     *
     * @fires change
     */
    __privateAdd(this, _handleSelectionChange);
    __privateAdd(this, _registerAutoCloseListener);
    __privateAdd(this, _unregisterAutoCloseListener);
    this.label = "";
    this.open = false;
    this.searchable = false;
    this.multiple = false;
    this.compareWith = (a, b) => a === b;
    this.searchFilter = (q, o) => o.innerHTML.toLowerCase().includes(q.toLowerCase());
    this.syncPopoverWidth = false;
    this.maxHeight = 500;
    this.size = "medium";
    this.hideLabel = false;
    this.disableMobileStyles = false;
    __privateAdd(this, _optionElements, void 0);
    __privateAdd(this, _calcMaxHeight, (trigger) => {
      const triggerRect = trigger.getBoundingClientRect();
      const windowHeight = window.innerHeight;
      const bottomSpace = windowHeight - triggerRect.bottom;
      const topSpace = triggerRect.top;
      let height = Math.min(topSpace, this.maxHeight);
      if (bottomSpace > topSpace)
        height = Math.min(bottomSpace, this.maxHeight);
      return `${height - 16}px`;
    });
    /**
     * Event handler for filtering the options in the dropdown.
     *
     * @param e The keyboard event.
     */
    __privateAdd(this, _handleSearchFieldKeyUp, (e) => {
      const input = this._elSearchInput;
      const options = Array.from(__privateGet(this, _optionElements));
      options.forEach((o) => o.hidden = false);
      if (!input.value)
        return;
      const filteredOptions = options.filter(
        (o) => !this.searchFilter(input.value, o)
      );
      filteredOptions.forEach((o) => o.hidden = true);
    });
    /**
     * Check for ArrowDown or Tab in the search field.
     * If found, focus should be moved to the listbox.
     */
    __privateAdd(this, _handleSearchFieldKeyDown, (e) => {
      var _a;
      (_a = this._elListbox) == null ? void 0 : _a.then((listbox) => {
        if (e.key === "ArrowDown" || e.key === "Tab") {
          e.preventDefault();
          listbox.focus();
          return;
        }
      });
    });
    /**
     * Check for Tab in the listbox.
     * If found, focus should be moved to the search field.
     */
    __privateAdd(this, _handleListboxKeyDown, (e) => {
      var _a;
      if (e.key === "Tab" && this.searchable) {
        e.preventDefault();
        (_a = this._elSearchInput) == null ? void 0 : _a.focus();
        return;
      }
    });
    __privateAdd(this, _handleOptionFocusChange, (e) => {
      const triggerButton = this._elTriggerBtn;
      if (triggerButton)
        triggerButton.ariaActiveDescendantElement = e.target;
    });
    /**
     * A listener to close the dropdown when any other element is focused.
     */
    __privateAdd(this, _blurCloseListener, (e) => {
      const isFocusOutside = e instanceof FocusEvent && e.relatedTarget && !this.contains(e.relatedTarget);
      if (isFocusOutside)
        this.open = false;
    });
    __privateAdd(this, _tabCloseListener, (e) => {
      var _a;
      if (e.key === "Tab" && !this.searchable) {
        e.preventDefault();
        this.open = false;
        (_a = this._elTriggerBtn) == null ? void 0 : _a.focus();
      }
    });
    constrainSlots(this);
    updateWhenLocaleChanges(this);
    __privateSet(this, _optionElements, this.getElementsByTagName(
      getScopedTagName("gds-option")
    ));
  }
  get type() {
    return "gds-dropdown";
  }
  /**
   * Get the options of the dropdown.
   */
  get options() {
    return Array.from(__privateGet(this, _optionElements)).filter(
      (o) => !o.hasAttribute("isplaceholder")
    );
  }
  /**
   * Return the first option with a isPlaceholder attribute.
   * If no placeholder is found, this will be undefined.
   */
  get placeholder() {
    return Array.from(__privateGet(this, _optionElements)).find(
      (o) => o.hasAttribute("isplaceholder")
    );
  }
  /**
   * Returns the display value as a string.
   * If the dropdown is in multiple mode, this will be a comma separated list of the selected values.
   */
  get displayValue() {
    var _a, _b;
    let displayValue;
    if (Array.isArray(this.value)) {
      this.value.length > 2 ? displayValue = msg(str`${this.value.length} selected`) : displayValue = this.value.reduce(
        (acc, cur) => {
          var _a2;
          return acc + ((_a2 = this.options.find((v) => v.value === cur)) == null ? void 0 : _a2.innerHTML) + ", ";
        },
        ""
      ).slice(0, -2);
    } else {
      displayValue = (_a = this.options.find((v) => v.selected)) == null ? void 0 : _a.innerHTML;
    }
    return displayValue || ((_b = this.placeholder) == null ? void 0 : _b.innerHTML) || "";
  }
  connectedCallback() {
    super.connectedCallback();
    TransitionalStyles.instance.apply(this, "gds-dropdown");
    this.updateComplete.then(() => {
      this._handleLightDOMChange();
      this._handleValueChange();
    });
  }
  render() {
    return html`
      ${when(
      this.label && !this.hideLabel,
      () => html`<label for="trigger">${this.label}</label>`
    )}

      <span class="form-info"><slot name="sub-label"></slot></span>

      <gds-popover
        .label=${this.label}
        .open=${this.open}
        .calcMaxWidth=${(trigger) => this.syncPopoverWidth ? `${trigger.offsetWidth}px` : `auto`}
        .calcMaxHeight=${__privateGet(this, _calcMaxHeight)}
        .disableMobileStyles=${this.disableMobileStyles}
        @gds-ui-state=${(e) => this.open = e.detail.open}
      >
        <button
          id="trigger"
          name="trigger"
          aria-haspopup="listbox"
          slot="trigger"
          role="combobox"
          aria-owns="listbox"
          aria-controls="listbox"
          aria-expanded="${this.open}"
          aria-label="${this.label}"
          part="trigger"
          class=${classMap({ small: this.size === "small" })}
        >
          <slot name="trigger">
            <span>${unsafeHTML(this.displayValue)}</span>
          </slot>
          <div class="icon">
            <gds-icon-chevron-bottom></gds-icon-chevron-bottom>
          </div>
        </button>
        ${when(
      this.searchable,
      () => html`<input
              id="searchinput"
              type="text"
              aria-label="${msg("Filter available options")}"
              placeholder="${msg("Search")}"
              @keydown=${__privateGet(this, _handleSearchFieldKeyDown)}
              @keyup=${__privateGet(this, _handleSearchFieldKeyUp)}
            />`
    )}
        <gds-listbox
          id="listbox"
          .multiple="${ifDefined(this.multiple)}"
          .compareWith="${this.compareWith}"
          @change="${__privateMethod(this, _handleSelectionChange, handleSelectionChange_fn)}"
          @gds-focus="${__privateGet(this, _handleOptionFocusChange)}"
          @keydown=${__privateGet(this, _handleListboxKeyDown)}
        >
          <slot gds-allow="gds-option gds-menu-heading"></slot>
        </gds-listbox>
      </gds-popover>

      <span class="form-info"
        ><slot name="message">${this.validationMessage}</slot></span
      >
    `;
  }
  _getValidityAnchor() {
    return this._elTriggerBtn;
  }
  _handleLightDOMChange() {
    var _a, _b;
    this.requestUpdate();
    if (this.multiple) {
      this._handleValueChange();
      return;
    }
    if (this.value === void 0) {
      if (this.placeholder)
        this.value = this.placeholder.value;
      else
        this.value = (_a = this.options[0]) == null ? void 0 : _a.value;
    } else if (!this.placeholder && this.options.find(
      (o) => this.compareWith(o.value, this.value)
    ) === void 0) {
      this.options[0] && (this.options[0].selected = true);
      this.value = (_b = this.options[0]) == null ? void 0 : _b.value;
    }
  }
  _handleValueChange() {
    this._elListbox.then((listbox) => {
      if (listbox) {
        if (Array.isArray(this.value))
          listbox.selection = this.value;
        else
          listbox.selection = [this.value];
      }
    });
  }
  _onOpenChange() {
    const open = this.open;
    Array.from(__privateGet(this, _optionElements)).forEach((o) => o.hidden = !open);
    if (open)
      __privateMethod(this, _registerAutoCloseListener, registerAutoCloseListener_fn).call(this);
    else {
      __privateMethod(this, _unregisterAutoCloseListener, unregisterAutoCloseListener_fn).call(this);
      this._elSearchInput && (this._elSearchInput.value = "");
    }
    this.dispatchEvent(
      new CustomEvent("gds-ui-state", {
        detail: { open },
        bubbles: true,
        composed: true
      })
    );
  }
};
_optionElements = new WeakMap();
_calcMaxHeight = new WeakMap();
_handleSearchFieldKeyUp = new WeakMap();
_handleSearchFieldKeyDown = new WeakMap();
_handleListboxKeyDown = new WeakMap();
_handleOptionFocusChange = new WeakMap();
_handleSelectionChange = new WeakSet();
handleSelectionChange_fn = function() {
  this._elListbox.then((listbox) => {
    var _a;
    if (this.multiple)
      this.value = listbox.selection.map((s) => s.value);
    else {
      this.value = (_a = listbox.selection[0]) == null ? void 0 : _a.value;
      this.open = false;
      setTimeout(() => {
        var _a2;
        return (_a2 = this._elTriggerBtn) == null ? void 0 : _a2.focus();
      }, 0);
    }
    this.dispatchEvent(
      new CustomEvent("change", {
        detail: { value: this.value },
        bubbles: true,
        composed: true
      })
    );
  });
};
_registerAutoCloseListener = new WeakSet();
registerAutoCloseListener_fn = function() {
  this.addEventListener("blur", __privateGet(this, _blurCloseListener));
  this.addEventListener("gds-blur", __privateGet(this, _blurCloseListener));
  this.addEventListener("keydown", __privateGet(this, _tabCloseListener));
};
_unregisterAutoCloseListener = new WeakSet();
unregisterAutoCloseListener_fn = function() {
  this.removeEventListener("blur", __privateGet(this, _blurCloseListener));
  this.removeEventListener("gds-blur", __privateGet(this, _blurCloseListener));
  this.removeEventListener("keydown", __privateGet(this, _tabCloseListener));
};
_blurCloseListener = new WeakMap();
_tabCloseListener = new WeakMap();
GdsDropdown.styles = [tokens, dropdown_styles_default];
GdsDropdown.shadowRootOptions = {
  mode: "open",
  delegatesFocus: true
};
__decorateClass([
  property()
], GdsDropdown.prototype, "label", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsDropdown.prototype, "open", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsDropdown.prototype, "searchable", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsDropdown.prototype, "multiple", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "compareWith", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "searchFilter", 2);
__decorateClass([
  property({ type: Boolean, attribute: "sync-popover-width" })
], GdsDropdown.prototype, "syncPopoverWidth", 2);
__decorateClass([
  property({ type: Number, attribute: "max-height" })
], GdsDropdown.prototype, "maxHeight", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "size", 2);
__decorateClass([
  property({ type: Boolean, attribute: "hide-label" })
], GdsDropdown.prototype, "hideLabel", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "disableMobileStyles", 2);
__decorateClass([
  query("#trigger")
], GdsDropdown.prototype, "_elTriggerBtn", 2);
__decorateClass([
  queryAsync("#listbox")
], GdsDropdown.prototype, "_elListbox", 2);
__decorateClass([
  query("#searchinput")
], GdsDropdown.prototype, "_elSearchInput", 2);
__decorateClass([
  observeLightDOM({
    attributes: true,
    childList: true,
    subtree: true,
    characterData: true
  })
], GdsDropdown.prototype, "_handleLightDOMChange", 1);
__decorateClass([
  watch("value")
], GdsDropdown.prototype, "_handleValueChange", 1);
__decorateClass([
  watch("open")
], GdsDropdown.prototype, "_onOpenChange", 1);
GdsDropdown = __decorateClass([
  gdsCustomElement("gds-dropdown")
], GdsDropdown);

export {
  GdsDropdown
};
