import {
  styleExpressionProperty
} from "./chunk.6UWYSL2J.js";
import {
  tokens
} from "./chunk.MM4R6TVG.js";
import {
  GdsElement
} from "./chunk.VDIB4JW2.js";
import {
  gdsCustomElement
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/content/text/text.ts
import { classMap } from "lit/directives/class-map.js";
import { html, unsafeStatic } from "lit/static-html.js";
import { property } from "lit/decorators.js";

// libs/core/src/components/content/text/text.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: contents;
  }

  * {
    margin: unset;
    font-weight: inherit;
    font-size: inherit;
    line-height: inherit;
    text-wrap: inherit;
  }

  h1.no-size-set {
    font-size: var(--gds-text-size-heading-xl);
    line-height: var(--gds-text-line-height-heading-xl);
    font-weight: var(--gds-text-weight-regular);
  }

  h2.no-size-set {
    font-size: var(--gds-text-size-heading-l);
    line-height: var(--gds-text-line-height-heading-l);
    font-weight: var(--gds-text-weight-regular);
  }

  h3.no-size-set {
    font-size: var(--gds-text-size-heading-m);
    line-height: var(--gds-text-line-height-heading-m);
    font-weight: var(--gds-text-weight-regular);
  }

  h4.no-size-set {
    font-size: var(--gds-text-size-heading-s);
    line-height: var(--gds-text-line-height-heading-s);
    font-weight: var(--gds-text-weight-regular);
  }

  h5.no-size-set {
    font-size: var(--gds-text-size-heading-xs);
    line-height: var(--gds-text-line-height-heading-xs);
    font-weight: var(--gds-text-weight-regular);
  }

  h6.no-size-set {
    font-size: var(--gds-text-size-heading-2xs);
    line-height: var(--gds-text-line-height-heading-2xs);
    font-weight: var(--gds-text-weight-regular);
  }

  p.no-size-set,
  span.no-size-set,
  em.no-size-set,
  strong.no-size-set,
  mark.no-size-set {
    font-size: var(--gds-text-size-body-m);
    line-height: var(--gds-text-line-height-body-m);
  }

  small.no-size-set {
    font-size: var(--gds-text-size-detail-xs);
    line-height: var(--gds-text-line-height-detail-xs);
  }

  strong.no-weight-set {
    font-weight: var(--gds-text-weight-book);
  }

  .lines-set {
    display: -webkit-box;
    -webkit-box-orient: vertical;
    overflow: hidden;
    -webkit-line-clamp: var(--_lines);
  }
`;
var text_style_default = style;

// libs/core/src/components/content/text/text.ts
var GdsText = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.level = "2";
    this.tag = "span";
  }
  render() {
    const TAG_ENCODE = encodeURI(this.tag);
    const TAG = unsafeStatic(TAG_ENCODE);
    const classes = {
      "no-size-set": !this["font-size"],
      "no-weight-set": !this["font-weight"],
      "lines-set": !!this.lines
    };
    return html`<${TAG} tag class=${classMap(classes)}><slot></slot></${TAG}>`;
  }
};
GdsText.styles = [tokens, text_style_default];
__decorateClass([
  property()
], GdsText.prototype, "level", 2);
__decorateClass([
  property({ type: String })
], GdsText.prototype, "tag", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`,
    selector: "[tag]",
    styleTemplate: (prop, values) => {
      const size = values[0];
      const styleSize = `font-size: var(--gds-text-size-${size});`;
      const styleLine = `line-height: var(--gds-text-line-height-${size});`;
      return styleSize + styleLine;
    }
  })
], GdsText.prototype, "font-size", 2);
__decorateClass([
  styleExpressionProperty({
    property: "font-weight",
    selector: "[tag]",
    valueTemplate: (v) => `var(--gds-text-weight-${v})`
  })
], GdsText.prototype, "font-weight", 2);
__decorateClass([
  styleExpressionProperty({
    property: "margin",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "margin", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "isolation", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-wrap",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "text-wrap", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-transform",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "text-transform", 2);
__decorateClass([
  styleExpressionProperty({
    property: "max-width",
    selector: "[tag]",
    valueTemplate: (v) => `${v}ch`
  })
], GdsText.prototype, "max-width", 2);
__decorateClass([
  styleExpressionProperty({
    property: "min-width",
    selector: "[tag]",
    valueTemplate: (v) => `${v}ch`
  })
], GdsText.prototype, "min-width", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-align",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "text-align", 2);
__decorateClass([
  styleExpressionProperty({
    property: "--_lines",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "lines", 2);
__decorateClass([
  styleExpressionProperty({
    property: "color",
    selector: "[tag]",
    valueTemplate: function(v) {
      const [colorName, transparency] = v.split("/");
      if (transparency) {
        return `color-mix(in srgb, var(--gds-color-${"l" + this.level}-content-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)`;
      } else {
        return `var(--gds-color-${"l" + this.level}-content-${colorName})`;
      }
    }
  })
], GdsText.prototype, "color", 2);
GdsText = __decorateClass([
  gdsCustomElement("gds-text")
], GdsText);

export {
  GdsText
};
