import {
  styleExpressionProperty
} from "./chunk.6UWYSL2J.js";
import {
  tokens
} from "./chunk.MM4R6TVG.js";
import {
  GdsElement
} from "./chunk.VDIB4JW2.js";
import {
  gdsCustomElement
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/primitives/signal/signal.ts
import { html } from "lit/static-html.js";

// libs/core/src/primitives/signal/signal.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: contents;
  }

  [part='signal'] {
    display: flex;
    align-items: center;
    justify-content: center;
    position: relative;
    width: 6px;
    height: 6px;
    border-radius: var(--gds-space-max);
    background-color: currentColor;
    transition: all 0.4s;

    &::before {
      display: flex;
      position: absolute;
      content: '';
      inset: -4px;
      border-radius: inherit;
      background-color: color-mix(in srgb, currentColor, transparent 80%);
      animation: signal 3s ease-in-out infinite;
    }
  }

  @keyframes signal {
    0% {
      transform: scale(2);
      opacity: 0;
    }
    60% {
      transform: scale(1);
      opacity: 1;
    }
    100% {
      transform: scale(3);
      opacity: 0;
    }
  }
`;
var signal_style_default = style;

// libs/core/src/primitives/signal/signal.ts
var GdsSignal = class extends GdsElement {
  render() {
    return html`<div part="signal"></div>`;
  }
};
GdsSignal.styles = [tokens, signal_style_default];
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `var(--gds-color-${v})`,
    selector: '[part="signal"]'
  })
], GdsSignal.prototype, "color", 2);
GdsSignal = __decorateClass([
  gdsCustomElement("gds-signal")
], GdsSignal);

export {
  GdsSignal
};
