import {
  Focusable,
  option_styles_default
} from "./chunk.27E4EAEK.js";
import {
  TransitionalStyles
} from "./chunk.CWRLA7VT.js";
import {
  watch
} from "./chunk.2WO4NHJ2.js";
import {
  tokens
} from "./chunk.MM4R6TVG.js";
import {
  GdsElement
} from "./chunk.VDIB4JW2.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod,
  __privateSet
} from "./chunk.5VURDMKE.js";

// libs/core/src/primitives/listbox/option.ts
import { property } from "lit/decorators.js";
import { when } from "lit/directives/when.js";
import { classMap } from "lit/directives/class-map.js";
var _hidden, _emitSelect, emitSelect_fn;
var GdsOption = class extends Focusable(GdsElement) {
  constructor() {
    super();
    __privateAdd(this, _emitSelect);
    __privateAdd(this, _hidden, false);
    this.selected = false;
    this.isPlaceholder = false;
    this.addEventListener("click", __privateMethod(this, _emitSelect, emitSelect_fn));
    this.addEventListener("keydown", (e) => {
      if (e.key !== "Enter" && e.key !== " ")
        return;
      e.preventDefault();
      __privateMethod(this, _emitSelect, emitSelect_fn).call(this, e);
    });
  }
  get hidden() {
    return __privateGet(this, _hidden);
  }
  set hidden(value) {
    if (this.isPlaceholder)
      return;
    __privateSet(this, _hidden, value === "true" || value === true);
    this.setAttribute("aria-hidden", value.toString());
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "option");
    if (this.isPlaceholder) {
      __privateSet(this, _hidden, true);
      this.setAttribute("aria-hidden", "true");
    }
    this.updateComplete.then(
      () => TransitionalStyles.instance.apply(this, "gds-option")
    );
  }
  get parentElement() {
    return super.parentElement;
  }
  _handlePlaceholderStatusChange() {
    if (this.isPlaceholder) {
      __privateSet(this, _hidden, true);
      this.setAttribute("aria-hidden", "true");
    } else {
      __privateSet(this, _hidden, false);
      this.setAttribute("aria-hidden", "false");
    }
  }
  render() {
    var _a;
    const isMultiple = (_a = this.parentElement) == null ? void 0 : _a.multiple;
    const checkbox = html`
      <span class="checkbox ${classMap({ checked: this.selected })}">
        ${this.selected ? html`<gds-icon-checkmark stroke="4"></gds-icon-checkmark>` : ""}
      </span>
    `;
    if (!isMultiple) {
      if (this.selected)
        this.setAttribute("highlighted", "");
      else
        this.removeAttribute("highlighted");
    }
    return html`<div>${when(isMultiple, () => checkbox)} <slot></slot></div>`;
  }
};
_hidden = new WeakMap();
_emitSelect = new WeakSet();
emitSelect_fn = function(e) {
  e.stopPropagation();
  this.dispatchEvent(
    new CustomEvent("gds-select", {
      bubbles: true,
      composed: true,
      detail: {
        value: this.value
      }
    })
  );
};
GdsOption.styles = [tokens, option_styles_default];
__decorateClass([
  property()
], GdsOption.prototype, "value", 2);
__decorateClass([
  property({
    attribute: "aria-hidden",
    reflect: true
  })
], GdsOption.prototype, "hidden", 1);
__decorateClass([
  property({
    attribute: "aria-selected",
    reflect: true
  })
], GdsOption.prototype, "selected", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsOption.prototype, "isPlaceholder", 2);
__decorateClass([
  watch("isplaceholder")
], GdsOption.prototype, "_handlePlaceholderStatusChange", 1);
GdsOption = __decorateClass([
  gdsCustomElement("gds-option")
], GdsOption);

export {
  GdsOption
};
