import { GdsElement } from '../../gds-element';
import { ListboxKbNavigation } from '../../controllers/listbox-kb-nav-controller';
import '../../primitives/menu/menu-item';
import type { GdsMenuItem } from '../../primitives/menu/menu-item';
/**
 * @element gds-menu
 * @internal
 *
 * A menu generally represents a grouping of common actions or functions that the user can invoke.
 * This primitive corresponds to the aria menu role: https://developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA/Roles/menu_role
 *
 * * @slot - The default slot. Only `gds-menu-item` elements should be used here.
 */
export declare class GdsMenu extends GdsElement implements ListboxKbNavigation {
    #private;
    constructor();
    connectedCallback(): void;
    get navigableItems(): GdsMenuItem[];
    /**
     * Focuses the first item in the menu.
     */
    focus(): void;
    render(): any;
}
